install(){	
	echo "Installing WLM components"
	sudo apt-get update
	sudo DEBIAN_FRONTEND=noninteractive apt-get install -y linux-tools-common \
		linux-tools-generic \
		linux-tools-`uname -r` \
		python3-pip \
		python3-venv \
		libssl-dev

	python3 -m venv wlmvenv
	source wlmvenv/bin/activate
	pip3 install -r requirement.txt
	deactivate

        sudo sh -c "echo '-1' > /proc/sys/kernel/perf_event_paranoid"

	sudo -H pip3 install -r requirement.txt

	echo "Creating wlm.service"
	#create systemd service file
	sudo rm -rf /lib/systemd/system/wlm.service
	sudo touch /lib/systemd/system/wlm.service
	sudo sh -c "echo '[Unit]' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'Description = WLM Service' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo '[Service]' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'User'=root >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'WorkingDirectory=${WLM_PATH}' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'Environment=XAUTHORITY=$home/.Xauthority' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'Environment=DISPLAY=:0' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'ExecStart=${WLM_PATH}/wlmvenv/bin/uwsgi --master --processes 1  --https 0.0.0.0:7000,${CERT_FILE},${KEY_FILE} -w wsgi:app --die-on-term' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo '[Install]' >> /lib/systemd/system/wlm.service"
	sudo sh -c "echo 'WantedBy=multi-user.target' >> /lib/systemd/system/wlm.service"

	#start systemd service
	sudo systemctl daemon-reload
	sudo systemctl enable wlm.service
        sudo systemctl start wlm.service
        status=$(sudo systemctl is-active wlm.service)
	echo "wlm.service is now $status"
}

uninstall(){

	echo "Uninstalling WLM components ..."

	sudo systemctl stop wlm.service
	sudo systemctl disable wlm.service
	sudo rm /lib/systemd/system/wlm.service 
	sudo systemctl daemon-reload
	sudo systemctl reset-failed
    status=$(sudo systemctl is-active wlm.service)
	echo "wlm.service is now $status"
}

if [ $1 == 'install' ]; then
	install
elif [ $1 == 'uninstall' ]; then
	uninstall
else
	echo "undefined argument."
fi
